curl -s \
"https://engine.example.com/v1/distributions/d-a1895c6f-a291/restatement-preview?point=00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3" \
-H "Authorization: Bearer $TOKEN"// A client from OpenAPI Generator: see Build a client.
import {
Configuration,
DistributionsApi,
ProblemFromJSON,
ResponseError,
} from "./nodeasset-client";
const api = new DistributionsApi(new Configuration({
basePath: "https://engine.example.com",
accessToken: process.env.TOKEN,
}));
try {
const answer = await api.getRestatementPreview({
distributionId: "d-a1895c6f-a291",
point: "00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3",
});
console.log(answer.value);
} catch (e) {
if (!(e instanceof ResponseError)) throw e;
// A refusal is a problem; its type ends in the slug.
const problem = ProblemFromJSON(await e.response.json());
const slug = problem.type.split(":").pop();
console.error(e.response.status, slug, problem.detail);
}
# A client from OpenAPI Generator: see Build a client.
import os
import sys
import nodeasset_client
config = nodeasset_client.Configuration(
host="https://engine.example.com",
access_token=os.environ["TOKEN"],
)
with nodeasset_client.ApiClient(config) as client:
api = nodeasset_client.DistributionsApi(client)
try:
answer = api.get_restatement_preview(
distribution_id="d-a1895c6f-a291",
point="00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3",
)
print(answer.value)
except nodeasset_client.ApiException as e:
# A refusal is a problem; its type ends in the slug.
problem = nodeasset_client.Problem.from_json(e.body)
slug = problem.type.rsplit(":", 1)[-1]
print(e.status, slug, problem.detail, file=sys.stderr)
// A client from OpenAPI Generator: see Build a client.
import nodeasset.client.ApiClient;
import nodeasset.client.ApiException;
import nodeasset.client.api.DistributionsApi;
import nodeasset.client.model.Problem;
public class GetRestatementPreview {
public static void main(String[] args) throws Exception {
ApiClient client = new ApiClient();
client.updateBaseUri("https://engine.example.com");
client.setRequestInterceptor(builder ->
builder.header("Authorization", "Bearer " + System.getenv("TOKEN")));
DistributionsApi api = new DistributionsApi(client);
try {
var request = DistributionsApi.APIGetRestatementPreviewRequest.newBuilder()
.distributionId("d-a1895c6f-a291")
.point("00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3")
.build();
var answer = api.getRestatementPreview(request);
System.out.println(answer.getValue());
} catch (ApiException e) {
// A refusal is a problem; its type ends in the slug.
Problem problem = client.getObjectMapper()
.readValue(e.getResponseBody(), Problem.class);
String type = problem.getType();
String slug = type.substring(type.lastIndexOf(':') + 1);
System.err.println(e.getCode() + " " + slug + " " + problem.getDetail());
}
}
}
{
"offset": 704,
"now": "2026-10-02T14:04:18.111312836Z",
"value": {
"distributionId": "d-a1895c6f-a291",
"instrumentId": "FUND",
"period": "2026-10",
"executed": {
"asOf": "2026-10-02T13:48:14.321664Z",
"nav": 1.003,
"withholdingRate": 0.154,
"pointContractId": "0077a58330200a39d48ee12a8cf48c76a73699754bd6e3a838b0f7d10d7bcbf18cc6b5c14b6accfaa75eb4496300e6abd9a570c810b7de369aaa0f87c968602d07ca7c197f"
},
"corrected": {
"asOf": "2026-10-02T14:04:17.183708Z",
"nav": 1.006011,
"withholdingRate": 0.1,
"pointContractId": "0030100306533e14e813cf4038652516663960841a01f626153ea142acd4a8c5bfaecdada2e493280e7150988f4c597f277b6fbdd0ba174386c49e42f03cfc6a2607f6c491"
},
"lines": [
{
"account": {
"owner": "alpha::12207ae69b2ef2f1249abd41923a06ee30bffa9298a17b0a875355c441bf32045d73",
"provider": null,
"id": ""
},
"executed": {
"gross": 15,
"withheld": 2.31,
"payout": 12.69
},
"corrected": {
"gross": 30.0099700897,
"withheld": 3.000997009,
"payout": 27
},
"delta": {
"gross": 15.0099700897,
"withheld": 0.690997009,
"payout": 14.31
}
}
],
"executedTotal": {
"gross": 237321,
"withheld": 36547.434,
"payout": 200773.56
},
"correctedTotal": {
"gross": 475455.5300933599,
"withheld": 47545.553009336,
"payout": 427909.95
},
"deltaTotal": {
"gross": 238134.5300933599,
"withheld": 10998.119009336,
"payout": 227136.39
}
}
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}Get a restatement preview
Returns, per holder line, the executed plan beside one recomputed at a corrected oracle point. It changes nothing.
curl -s \
"https://engine.example.com/v1/distributions/d-a1895c6f-a291/restatement-preview?point=00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3" \
-H "Authorization: Bearer $TOKEN"// A client from OpenAPI Generator: see Build a client.
import {
Configuration,
DistributionsApi,
ProblemFromJSON,
ResponseError,
} from "./nodeasset-client";
const api = new DistributionsApi(new Configuration({
basePath: "https://engine.example.com",
accessToken: process.env.TOKEN,
}));
try {
const answer = await api.getRestatementPreview({
distributionId: "d-a1895c6f-a291",
point: "00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3",
});
console.log(answer.value);
} catch (e) {
if (!(e instanceof ResponseError)) throw e;
// A refusal is a problem; its type ends in the slug.
const problem = ProblemFromJSON(await e.response.json());
const slug = problem.type.split(":").pop();
console.error(e.response.status, slug, problem.detail);
}
# A client from OpenAPI Generator: see Build a client.
import os
import sys
import nodeasset_client
config = nodeasset_client.Configuration(
host="https://engine.example.com",
access_token=os.environ["TOKEN"],
)
with nodeasset_client.ApiClient(config) as client:
api = nodeasset_client.DistributionsApi(client)
try:
answer = api.get_restatement_preview(
distribution_id="d-a1895c6f-a291",
point="00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3",
)
print(answer.value)
except nodeasset_client.ApiException as e:
# A refusal is a problem; its type ends in the slug.
problem = nodeasset_client.Problem.from_json(e.body)
slug = problem.type.rsplit(":", 1)[-1]
print(e.status, slug, problem.detail, file=sys.stderr)
// A client from OpenAPI Generator: see Build a client.
import nodeasset.client.ApiClient;
import nodeasset.client.ApiException;
import nodeasset.client.api.DistributionsApi;
import nodeasset.client.model.Problem;
public class GetRestatementPreview {
public static void main(String[] args) throws Exception {
ApiClient client = new ApiClient();
client.updateBaseUri("https://engine.example.com");
client.setRequestInterceptor(builder ->
builder.header("Authorization", "Bearer " + System.getenv("TOKEN")));
DistributionsApi api = new DistributionsApi(client);
try {
var request = DistributionsApi.APIGetRestatementPreviewRequest.newBuilder()
.distributionId("d-a1895c6f-a291")
.point("00ee4dba2a9e8785f8a53eb0e3ff6ce28c4f459f14ee4b11684e563e5910ba5b13ca121220a74431eb9c6959e8038ccc1a3af9df0ea3706f1541db9184b50d62c50f5c98a3")
.build();
var answer = api.getRestatementPreview(request);
System.out.println(answer.getValue());
} catch (ApiException e) {
// A refusal is a problem; its type ends in the slug.
Problem problem = client.getObjectMapper()
.readValue(e.getResponseBody(), Problem.class);
String type = problem.getType();
String slug = type.substring(type.lastIndexOf(':') + 1);
System.err.println(e.getCode() + " " + slug + " " + problem.getDetail());
}
}
}
{
"offset": 704,
"now": "2026-10-02T14:04:18.111312836Z",
"value": {
"distributionId": "d-a1895c6f-a291",
"instrumentId": "FUND",
"period": "2026-10",
"executed": {
"asOf": "2026-10-02T13:48:14.321664Z",
"nav": 1.003,
"withholdingRate": 0.154,
"pointContractId": "0077a58330200a39d48ee12a8cf48c76a73699754bd6e3a838b0f7d10d7bcbf18cc6b5c14b6accfaa75eb4496300e6abd9a570c810b7de369aaa0f87c968602d07ca7c197f"
},
"corrected": {
"asOf": "2026-10-02T14:04:17.183708Z",
"nav": 1.006011,
"withholdingRate": 0.1,
"pointContractId": "0030100306533e14e813cf4038652516663960841a01f626153ea142acd4a8c5bfaecdada2e493280e7150988f4c597f277b6fbdd0ba174386c49e42f03cfc6a2607f6c491"
},
"lines": [
{
"account": {
"owner": "alpha::12207ae69b2ef2f1249abd41923a06ee30bffa9298a17b0a875355c441bf32045d73",
"provider": null,
"id": ""
},
"executed": {
"gross": 15,
"withheld": 2.31,
"payout": 12.69
},
"corrected": {
"gross": 30.0099700897,
"withheld": 3.000997009,
"payout": 27
},
"delta": {
"gross": 15.0099700897,
"withheld": 0.690997009,
"payout": 14.31
}
}
],
"executedTotal": {
"gross": 237321,
"withheld": 36547.434,
"payout": 200773.56
},
"correctedTotal": {
"gross": 475455.5300933599,
"withheld": 47545.553009336,
"payout": 427909.95
},
"deltaTotal": {
"gross": 238134.5300933599,
"withheld": 10998.119009336,
"payout": 227136.39
}
}
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}{
"type": "<string>",
"title": "<string>",
"status": 123,
"detail": "<string>",
"requestId": "<string>",
"gate": "<string>",
"check": "<string>",
"recovery": "<string>",
"retryAfter": 123,
"retryable": true,
"packageName": "<string>",
"party": "<string>",
"contractId": "<string>",
"projectionOffset": 123,
"ledgerEnd": 123,
"code": 123,
"reason": "<string>",
"policyVersion": 123,
"errors": [
{
"pointer": "<string>",
"detail": "<string>"
}
]
}approver, auditor, operator, risk.Authorizations
A JWT from the deployment's identity provider, whose roles claim names the caller's roles and whose holder claim names an investor's holder.
Headers
A signed request's key id, as venue.api.signing.clients configures it for the bearer's subject.
Seconds since the epoch, within venue.api.signing.window of the engine's clock, 5 minutes by default.
^[0-9]+$At least 16 random bytes in base64url, never reused within twice the window.
22 - 128^[A-Za-z0-9_-]+={0,2}$The base64 HMAC-SHA256, under the key's secret, of the method, the path and query, the timestamp, the nonce and the body's SHA-256.
Your id for this request, 1 to 128 printable characters, repeated in the answer; absent, the engine makes one.
128^[\x21-\x7E]+$A W3C trace context, which the engine joins and passes on.
^[0-9a-f]{2}-[0-9a-f]{32}-[0-9a-f]{16}-[0-9a-f]{2}$Path Parameters
The distribution's id.
Query Parameters
The contract id of the oracle point that corrects the plan's.
Response
The restatement preview.
The ledger offset the answer was read at; 0 for an answer from the engine's own records.
The engine's clock when it answered, an ISO-8601 instant.
What the read answers; for a list, the page's records in the list's order.
Show child attributes
Show child attributes

